	TITLE "EZIP/6502-C INFOCOM, INC. --- EQUATES"

	; --------------------------
	; EZIP/6502 VERSION A
	; Z-CODE INTERPRETER PROGRAM
	; FOR COMMODORE 128
	; --------------------------

	; INFOCOM, INC.
	; 125 CAMBRIDGEPARK DRIVE
	; CAMBRIDGE, MA 02140

	; COMPANY PRIVATE -- NOT FOR DISTRIBUTION

	PL	58		; PAGE LENGTH OF PRINTER

ZEROPG	EQU	$03		; START OF FREE Z-PAGE RAM
ZPGTOP	EQU	$8F		; END OF FREE Z-PAGE RAM

DEBUG	EQU	0		; ASSEMBLY FLAG FOR DEBUGGER (1=YES,0=NO)
TESTING	EQU	1		; ASS. FLG FOR TESTING MSG

VERSID	EQU	'E'	; VERSION OF INTERPRETER

	; VERSIONS
	; a-b - dunno
	; c - 6/10/87 jdarnold
	;	SAVE/RESTORE cursor position when switching
	;		around between windows
	;	and also don't let the top window scroll
	; D - 7/23/87 J.D. Arnold
	;	Don't let number of saves go past 9
	;
	; E - 7/32/87 jdarnold
	; 	start the cursor off at the bottom of the screen
	;

	; -----------
	; ERROR CODES
	; -----------

	; 00 -- INSUFFICIENT RAM
	; 01 -- ILLEGAL X-OP
	; 02 -- ILLEGAL 0-OP
	; 03 -- ILLEGAL 1-OP
	; 04 -- ILLEGAL 2-OP
	; 05 -- Z-STACK UNDERFLOW
	; 06 -- Z-STACK OVERFLOW
	; 07 -- ILLEGAL PROPERTY LENGTH (GETP)
	; 08 -- DIVISION BY ZERO
	; 09 -- ILLEGAL ARGUMENT COUNT (EQUAL?)
	; 10 -- ILLEGAL PROPERTY ID (PUTP)
	; 11 -- ILLEGAL PROPERTY LENGTH (PUTP)
	; 12 -- DISK ADDRESS OUT OF RANGE
	; 13 -- PRELOAD/IMPURE TOO LARGE
	; 14 -- DRIVE ACCESS
	; 15 -- Z-STACK DESTROYED
	; 16 -- NOT AN EZIP GAME

	; NOTE: DISK ACCESS IS SET SO THAT SIDE 1 STARTS ON TRACK 3
	; SIDE 2 ON TRACK 1 AND SAVES STARTING ON TRACK 1. THIS IS IN 
	; THE CODE IN ZDOS.ASM (APPEARS NOWHERE ELSE 3/18/86 LE)

	INCLUDE EQ.ASM

	TITLE "EZIP/6502-C INFOCOM, INC. --- MACHINE DEPENDENT INIT"
	INCLUDE HARDEQ.ASM

;	INCLUDE BOOT.ASM
	INCLUDE MEMORY.ASM
	INCLUDE COLD.ASM

	TITLE "EZIP/6502-C INFOCOM, INC. --- INIT & MAINLINE"
	INCLUDE WARM.ASM
	INCLUDE MAIN.ASM
	INCLUDE SUBS.ASM
	INCLUDE DISPATCH.ASM

	TITLE "EZIP/6502-C INFOCOM, INC. --- OPCODE EXECUTORS"
	INCLUDE OPS012.ASM
	INCLUDE OPSX.ASM
	INCLUDE READ.ASM

	TITLE "EZIP/6502-C INFOCOM, INC. --- OP SUPPORT & MEMORY MANAGEMENT"
	INCLUDE XPAGING.ASM

	INCLUDE ZSTRING.ASM
	INCLUDE OBJECTS.ASM

	TITLE "EZIP/6502-C INFOCOM, INC. --- MACHINE DEPENDENT I/O"

	INCLUDE IO.ASM
	INCLUDE MACHINE.ASM
	INCLUDE ZDOS.ASM
	INCLUDE DISK.ASM

	IF	DEBUG
	INCLUDE BUGGER.ASM
	ENDIF

	TITLE "EZIP/6502-C INFOCOM, INC."

	END

